<template xmlns:v-slot="http://www.w3.org/1999/XSL/Transform">
    <v-layout align-center justify-center>



        <v-card max-width="90%">
            <v-card-title>
                <v-layout column>

                    <v-btn
                            color="green"
                            dark
                            small
                            absolute
                            top
                            left
                            fab
                            @click="add"
                    >
                        <v-icon light>add</v-icon>
                    </v-btn>
                    <v-data-table
                            :headers="headers"
                            :items="allData"
                            hide-actions
                    >
                        <template
                                slot="headerCell"
                                slot-scope="{ header }"
                        >
                    <span class="subheading font-weight-light text-success text--darken-3"
                          v-text="header.text"
                    ></span>

                        </template>
                        <template v-slot:no-data>
                            <div v-show="allDataLoading === true" class="justify-center layout px-0">
                                <v-progress-circular indeterminate color="primary"
                                                     align-center justify-center row></v-progress-circular>
                            </div>

                            <div v-show="allData.length === 0 && allDataLoading === false"
                                 class="justify-center layout px-0">
                                {{'داده ای وجود ندارد'}}
                            </div>

                        </template>
                        <template
                                slot="items"
                                slot-scope="{ item }"
                        >
                            <td>{{ item.name}}</td>
                            <td>{{ item.max_capacity}}</td>
                            <td>{{ item.vehicle_group.name}}</td>

                            <td class="justify-center layout px-0">
                                <v-icon
                                        small
                                        class="mr-2"
                                        @click="edit(item)"
                                >
                                    edit
                                </v-icon>

                                <v-icon
                                        small
                                        @click="deleteItem(item)"
                                >
                                    delete
                                </v-icon>
                            </td>
                        </template>
                    </v-data-table>
                </v-layout>
            </v-card-title>
        </v-card>
        <v-dialog v-model="AddDialog" persistent max-width="800px" max-height="700px">
            <v-card>
                <v-card-text>
                    <v-container grid-list-md>
                        <v-form
                                ref="form"
                                v-model="valid"
                                lazy-validation
                        >
                            <v-layout>
                                <v-flex>
                                    <v-text-field :rules="nameRules" @change="setName" v-model="selectedItem.name" label="اسم"></v-text-field>
                                </v-flex>
                                <v-flex>
                                    <v-text-field :rules="nameRules" type="number" @change="setMaxCapacity" v-model="selectedItem.max_capacity"
                                                  label="ظرفیت"></v-text-field>
                                </v-flex>

                                <v-flex xs12 sm4 md4>
                                    <v-select
                                            :rules="vehicleRules"
                                            v-model="selectedItem.vehicle_group.name"
                                            :items="allVehicleGroups"
                                            item-text="name"
                                            outlined
                                            label="نوع خودرو را انتخاب کنید"
                                            single-line
                                            @change="setSelectedVehicleGroup"
                                            return-object
                                    ></v-select>
                                </v-flex>
                            </v-layout>
                        </v-form>
                    </v-container>
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideAddDialog">لغو</v-btn>
                    <v-btn color="blue darken-1" flat @click="add_Edit">
                        <v-progress-circular v-show="this.pending === true" indeterminate
                                             color="white"></v-progress-circular>
                        <div v-show="this.pending === false">ذخیره</div>
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
        <v-dialog
                v-model="DeleteDialog"
                width="500"
        >

            <v-card>
                <v-card-text>
                    آیا مطمئن هستید که می خواهید این ماشین را حذف کنید؟
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideDeleteDialog">لغو</v-btn>
                    <v-btn color="blue darken-1" flat @click="deleteOne">
                        <v-progress-circular v-show="this.pending === true" indeterminate
                                             color="white"></v-progress-circular>
                        <div v-show="this.pending === false">حذف</div>
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
        <v-dialog
                v-model="AlertDialog"
                max-width="500"
        >

            <v-card>
                <v-card-text>
                    {{alertDialogMessage}}
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideAlertDialog">باشه</v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
    </v-layout>
</template>
<script>
    import {mapActions, mapMutations, mapState} from "vuex";

    export default {
        name: "vehicle",
        methods: {
            ...mapMutations({
                setName: 'vehicle/setName',
                setMaxCapacity: 'vehicle/setMaxCapacity',
                setSelectedVehicleGroup: 'vehicle/setSelectedVehicleGroup',
                setSelectedItem: 'vehicle/setSelectedItem',
                showAddDialog: 'vehicle/showAddDialog',
                hideAddDialog: 'vehicle/hideAddDialog',
                showDeleteDialog: 'vehicle/showDeleteDialog',
                hideDeleteDialog: 'vehicle/hideDeleteDialog',
                hideAlertDialog: 'vehicle/hideAlertDialog',
            }),
            ...mapActions({
                removeFilter: 'cargo/removeFilter',
                readData: 'vehicle/readData',
                addOrEdit: 'vehicle/addOrEdit',
                deleteOne: 'vehicle/deleteOne'
            }),

            add() {
                this.setSelectedItem({
                    id: null,
                    name: null,
                    max_capacity: null,
                    vehicle_group: {id: null, name: null}
                });
                this.showAddDialog();
            },
            edit(item) {
                this.setSelectedItem({
                    id: item.id,
                    name: item.name,
                    max_capacity: item.max_capacity,
                    vehicle_group: item.vehicle_group
                });
                this.showAddDialog();
            },
            add_Edit() {
                if (this.$refs.form.validate()) {
                    this.addOrEdit();
                }
            },

            deleteItem(item) {
                this.setSelectedItem(item);
                this.showDeleteDialog()
            },
        },
        computed: {
            ...mapState({
                allData: state => state.vehicle.allData,
                allVehicleGroups: state => state.vehicle.allVehicleGroups,
                AddDialog: state => state.vehicle.AddDialog,
                DeleteDialog: state => state.vehicle.DeleteDialog,
                selectedItem: state => state.vehicle.selectedItem,
                pending: state => state.vehicle.pending,
                allDataLoading: state => state.vehicle.allDataLoading,
                AlertDialog: state => state.vehicle.AlertDialog,
                alertDialogMessage: state => state.vehicle.alertDialogMessage,
                filter: state => state.vehicle.filter,

            })
        },
        mounted() {
            this.readData();
        },
        data() {
            return {
                valid: true,
                nameRules: [
                    v => !!v || 'این فیلد نمیتواند خالی باشد',
                ],
                vehicleRules: [
                    v => !!v || 'این فیلد نمیتواند خالی باشد',
                ],
                headers: [
                    {text: 'نام', align: 'right', value: 'name'},
                    {text: 'ظرفیت', align: 'right', value: 'max_capacity'},
                    {text: 'نوع خودرو', align: 'right', value: 'vehicle_group.name'},

                ],
            }
        },

    }
</script>
<style scoped>
</style>